import React, {
    Component,
} from 'react'

import PropTypes from 'prop-types';

import {
    View,
} from 'react-native'

import constants from './constants'

export default class RefreshView extends Component {

    static defaultProps = {
        renderRefreshContent: () => null,
    }

    static propTypes = {
        ...View.propTypes,
        renderRefreshContent: PropTypes.func,
    }

    constructor (props) {
        super(props)
        this.state = {
            pullState: props.viewType == constants.refreshViewType.header ? constants.viewState.refresh_none : constants.viewState.load_more_none,
            pullDistancePercent: 0,
        }
    }

    setNativeProps (props) {
        this._refreshView.setNativeProps(props)
    }

    render () {

        const { renderListHeader, style, ...otherProps } = this.props;

        return (
            <View
                pointerEvents={'box-none'}
                style={[{width:'100%'}]}
            >
                <View
                    ref={ component => this._refreshView = component }
                    pointerEvents={'none'}
                    style={[styles.container, style]}
                    {...otherProps}
                >
                    {this.props.renderRefreshContent(this.state)}
                </View>

                {renderListHeader && renderListHeader()}

            </View>
        )
    }

}

const styles = {
    container: {
        width:'100%',
        justifyContent: 'center',
        alignItems: 'center',
        backgroundColor:'transparent',
    }
};